#ifndef IR_cpp
#define IR_cpp

#include "IR.h"
#include <EEPROM.h>

enum { Intervals = 70 };
//byte Intervals=70;
byte pinir=9;


/*IRcontrol::IR()
{

}
 */

//    

void IR::pinIR(byte x)
{
pinir=x;
 pinMode(pinir, INPUT); //     
}

/*void IRcontrol::cycles(byte x)
{
Intervals=x;
}*/


char arrayfix[Intervals],array[Intervals]; //   
void IR::readEEPROM()
{
 for (byte x=0; x<Intervals; x++) //  EEPROM   (   =)
   {
   arrayfix[x]=EEPROM.read(x); 
   }
}

// 


byte z=1;

int IR::readIR()

{

int starttime, endtime, time;
byte n;
  if (digitalRead(pinir)==0) //  ..
  {
    starttime=micros();  
   while (digitalRead(pinir)==0); //..    .
   endtime=micros();
   time=endtime-starttime; //  .
   if (time>1000) //   ,    ,  .
    {

   while (n<Intervals) //     .
     {
  
    if (digitalRead(pinir)==0) //   (1)..
      {
    
    starttime=micros();
    while (digitalRead(pinir)==0);
    endtime=micros();
    time=endtime-starttime; // ...  .
   
    if (z==2 || z==3 ) //  ..
   
    arrayfix[n]=time/100;  //..   " " 
//     .
    array[n]=time/100;     //      .
    n++;
       }
    if (digitalRead(pinir)==1) //   (0)..
     {
       
    starttime=micros();
    
    while (digitalRead(pinir)==1) //    ,     ...
    {
     endtime=micros();
    time=endtime-starttime;
 
   if (time>10000)  //  ..., .   
//   0-,    .
      {
   while (n<Intervals)
        {
    if (z==2 || z==3)
    arrayfix[n]=0;
    array[n]=0 ;
   n++;
        }
   goto out; 
      }
    }   
    endtime=micros();
    time=endtime-starttime;
    if (z==2 || z==3)
    arrayfix[n]=-time/100; //      (-). 
    //  100  ,       1 ,     int.
    array[n]=-time/100;    
    n++;
    }
    
    }
    out: //  ,   .

    if (z==3)//  ,    EEPROM
    {
    for (byte x=0; x<Intervals; x++)
     {
   EEPROM.write(x, arrayfix[x]);
     }

    }
     n=0;

    

   byte distinction=0;
   int code=0;
   for (byte x=0; x<Intervals; x++) //          .
   {
    if (abs(array[x]-arrayfix[x])>5 && array[x]!=0 && arrayfix[x]!=0) //   ,
//      .
    //   500 ,      .
    {

    distinction++;
    code=code+(x+1)*distinction; // 
    }


    }

    if (z==2)
    {
    code=-2;
    z=1;
    }
    if (z==3)
    {code=-3;
    z=1;
    }
    return code;

 }
 }
 else return -1;
 //if (digitalRead(pinir)==1) return -1;
}

void IR::test()
{
 Serial.begin(9600);
 for (byte x=0; x<Intervals; x++)

    {
      Serial.print(x+1);
      Serial.print("   ");
      Serial.print(int(arrayfix[x]));
       Serial.print("   ");
        Serial.println(int(array[x]));
    }
}

boolean IR::writeMEMORY()
{
z=2;
if (readIR()==-2)
{
z=1;
return 1;
}
else
{
z=1;
return 0;
}


}

boolean IR::writeEEPROM()
{
z=3;
if (readIR()==-3)
{
z=1;
return 1;

}
else
{
z=1;
return 0;
}

}
#endif // #ifndef IR_cpp